The preliminaries package

[Tags:bsd3, library]

A GHC-only alternative to the Prelude with a large amount of imports available by default.


[Skip to Readme]

Properties

Versions 0.1.0.0, 0.1.1.0, 0.1.2.0, 0.1.3.0, 0.1.4.0, 0.1.5.0, 0.1.6.0
Dependencies abstract-par (>=0.3.3 && <1), base (>=4.9.0 && <5), bifunctors (>=5.4.1 && <6), classy-prelude-conduit (>=1.0.0 && <2), data-default (>=0.7.1 && <1), microlens-contra (>=0.1.0 && <1), microlens-platform (>=0.3.7 && <1), monad-par (>=0.3.4 && <1), monad-parallel (>=0.7.2 && <1), mono-traversable-instances (>=0.1.0 && <1), mtl (>=2.2.1 && <3), parallel (>=3.2.1 && <4), stm-conduit (>=3.0.0 && <4), string-conversions (>=0.4 && <1) [details]
License BSD3
Copyright © 2016 Yghor Kerscher
Author Yghor Kerscher
Maintainer kerscher@acm.org
Category Prelude
Home page http://github.com/kerscher/preliminaries
Source repository head: git clone https://github.com/kerscher/preliminaries
Uploaded Wed Feb 1 21:20:37 UTC 2017 by yghor
Distributions NixOS:0.1.6.0
Downloads 272 total (54 in the last 30 days)
Votes
0 []
Status Docs available [build log]
Last success reported on 2017-02-01 [all 1 reports]
Hackage Matrix CI

Modules

[Index]

Downloads

Maintainer's Corner

For package maintainers and hackage trustees

Readme for preliminaries

Readme for preliminaries-0.1.6.0

Preliminaries

Build Status Hackage BSD3 license

The Haskell Report specifies the Prelude with a minimal amount of definitions that are always available in scope for application writers. Due to its simplicity and frugality, multiple alternatives and support libraries were devised to improve upon it, including:

preliminaries is one of such alternatives and builds upon classy-prelude-conduit, with the following functionality out-of-the-box:

  • Data manipulation and structures — i.e. microlens + mono-traversable
  • Streaming
  • Concurrency
  • Parallelism
  • Read-only, write-only and read-write environments — i.e. mtl

Contrary to most other alternatives, there is no attempt at being minimal. Nevertheless, it's shipped with microlens instead of the full-blown lens.

Usage

To use it, put the following in your .cabal file, ignoring the “…” for omited parts:

executable your-executable
  language:           Haskell2010
  default-extensions: NoImplicitPrelude
  build-depends:      preliminaries >= 0.1.6 < 1
  …

And on each file, add import Preliminaries.

You might also want to look at this project’s Cabal file to check on useful GHC extensions to enable alongside this change.

Contributing

In case something does not build or you find other unpleasant aspects of the library, please send a pull request or contact the maintainer.